import java.io.*;

public class Nombre implements Serializable {
	private String nombre;
	private long id;
	private transient boolean hashSet= false;
	private transient int hash;
	
	private static long sigID= 0;
	
	public Nombre(String nombre) {
		this.nombre= nombre;
		synchronized (Nombre.class) {
			id= sigID++;
		}
	}
	
	public int hashCode() {
		if (!hashSet) {
			hash= nombre.hashCode();
			hashSet= true;
		}
		return hash;
	}
	
	public static void main (String[] args) 
		throws IOException, ClassNotFoundException {
		
		ObjectOutputStream objOutput= 	new ObjectOutputStream(
											new FileOutputStream("nombre.obj")
										);
		Nombre objNombre= new Nombre("Objeto a serializar");
		objNombre.hashCode();
		System.out.println("ANTES SERIALIZACION >>>");
		System.out.println("nombre= " + objNombre.nombre);
		System.out.println("id= " + objNombre.id);
		System.out.println("hash= " + objNombre.hash);
		System.out.println("hashSet= " + objNombre.hashSet);
		objOutput.writeObject(objNombre);
		objOutput.close();
		
		
		ObjectInputStream objInput=	new ObjectInputStream(
											new FileInputStream("nombre.obj")
									);
		Nombre objNombre2;
		objNombre2= (Nombre)objInput.readObject();
		System.out.println("DESPUES SERIALIZACION >>>");
		System.out.println("nombre= " + objNombre2.nombre);
		System.out.println("id= " + objNombre2.id);
		System.out.println("hash= " + objNombre2.hash);
		System.out.println("hashSet= " + objNombre2.hashSet);
		objInput.close();
	}
}
		
		