import java.io.*;

public class NombreMejorado implements Serializable {
	private String nombre;
	private long id;
	private transient int hash;
	
	private static long sigID= 0;
	
	public NombreMejorado(String nombre) {
		this.nombre= nombre;
		synchronized (Nombre.class) {
			id= sigID++;
		}
		hash= nombre.hashCode();
	}
	
	public void writeObject(ObjectOutputStream out)
			throws IOException {
		out.writeUTF(nombre); 	//out.defaultWriteObject();
		out.writeLong(id);		//
	}
	
	public void readObject(ObjectInputStream in)
			throws IOException, ClassNotFoundException {
		nombre= in.readUTF();	//in.defaultReadObject();
		id= in.readLong();		//
		hash= nombre.hashCode();
	}
	
	public int hashCode() {
		return hash;
	}
	
	public static void main (String[] args) 
		throws IOException, ClassNotFoundException {
		
		ObjectOutputStream objOut= 	new ObjectOutputStream(
											new FileOutputStream("nombre2.obj")
										);
		NombreMejorado objNombre= new NombreMejorado("Objeto a serializar");
		System.out.println("ANTES SERIALIZACION >>>");
		System.out.println("nombre= " + objNombre.nombre);
		System.out.println("id= " + objNombre.id);
		System.out.println("hash= " + objNombre.hash);
		objNombre.writeObject(objOut);
		objOut.close();
		
		
		ObjectInputStream objIn=	new ObjectInputStream(
											new FileInputStream("nombre2.obj")
									);
		NombreMejorado objNombre2= new NombreMejorado("");
		objNombre2.readObject(objIn);
		System.out.println("DESPUES SERIALIZACION >>>");
		System.out.println("nombre= " + objNombre2.nombre);
		System.out.println("id= " + objNombre2.id);
		System.out.println("hash= " + objNombre2.hash);
	}
}
		
		